unit OuvreDossierUnit1;
//http://www.phidels.com
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    ButtonInstallerRaccourcis: TButton;
    ButtonSupprimerRaccourcis: TButton;
    Memo1: TMemo;
    ButtonVoirDossierSendTo: TButton;
    procedure ButtonInstallerRaccourcisClick(Sender: TObject);
    procedure ButtonSupprimerRaccourcisClick(Sender: TObject);
    procedure ButtonVoirDossierSendToClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
Uses ShellApi, inifiles, ComObj, ShlObj, ActiveX;

function RenvoiDossier(VariableIdentifiantLeButDuGet:integer):string;
//Permet de rcuprer le nom d'un dossier gr par Windows (ici le dossier SendTo
var
  IdList:PITEMIDLIST;
  Dossier:array[0..MAX_PATH] of Char;
begin
  if SHGetSpecialFolderLocation(0, VariableIdentifiantLeButDuGet,IdList)
                                                                   =NOERROR then
  begin
    SHGetPathFromIDList(IdList, Dossier);
    result:=string(Dossier);
  end
  else   result:='';
end;



procedure CreFicLien(FicSource, FicRaccourci, Description, DossierDeTravail,
                     NomIconeAssociee :string; NumIcone:integer);
// cration d'un racourcis
var
  ShellLink : IShellLink;
begin
  if UpperCase(extractFileExt(FicRaccourci))<>'.LNK' then
     FicRaccourci:=FicRaccourci+'.lnk';
  ShellLink:=CreateComObject(CLSID_ShellLink) as IShellLink;
  ShellLink.SetDescription(PAnsiChar(Description));
  ShellLink.SetPath(PAnsiChar(FicSource));
  ShellLink.SetWorkingDirectory(PAnsiChar(DossierDeTravail));
  ShellLink.SetShowCmd(SW_SHOW);
  if (NomIconeAssociee<>'') then
              ShellLink.SetIconLocation(PAnsiChar(NomIconeAssociee), NumIcone);
  (ShellLink as IpersistFile).Save(StringToOleStr(FicRaccourci), true);
end;



function LanceFichier(NomFichier : string) : HINST;
// lance un fichier. Ici, Lancer le dossier signifiera ouvrir le dossier.
begin
   Result:=ShellExecute (Application.handle,'Open',  PChar(NomFichier) ,'',
   '',SW_SHOWNORMAL);
end;

procedure CreationRaccourciDansSendTo;
// Cration du fichier raccourci dans le dossier SendTo
begin
    if not FileExists(RenvoiDossier(CSIDL_SENDTO)+'\Ouvrir Dossier.lnk') then
    // si le raccourcis n'existe pas dans le dossier SendTo alors on le cre.
    begin
      if MessageDlg('Le programme va installer un raccourcis dans le dossier'
      +' SendTo. Ok ?',
      mtConfirmation, [mbYes, mbNo], 0) = mrYes then
              CreFicLien(Application.ExeName,RenvoiDossier(CSIDL_SENDTO)
              +'\Ouvrir Dossier','Ouverture du dossier'
               ,'','',0)
     else ShowMessage('Rien n''a t crer');
   end;

end;


procedure TForm1.ButtonInstallerRaccourcisClick(Sender: TObject);
begin
  CreationRaccourciDansSendTo;
end;

procedure TForm1.ButtonSupprimerRaccourcisClick(Sender: TObject);
begin
  if MessageDlg('Le programme va supprimer le raccourcis '
      +RenvoiDossier(CSIDL_SENDTO)+'\Ouvrir Dossier.lnk',
      mtConfirmation, [mbYes, mbNo], 0) = mrYes then
         DeleteFile(RenvoiDossier(CSIDL_SENDTO)+'\Ouvrir Dossier.lnk');
end;

procedure TForm1.ButtonVoirDossierSendToClick(Sender: TObject);
begin
  LanceFichier(RenvoiDossier(CSIDL_SENDTO)+'\');
end;

procedure TForm1.FormActivate(Sender: TObject);
var Dossier : string;
           i: integer;
begin
 if ParamCount>0 then // s'il y a un paramtre
 begin
   // rcupration du fichier qui est en paramtre
   for i:=1 to ParamCount do Dossier:=Dossier+ ParamStr(i);
   // on en extrait le dossier
   Dossier:=ExtractFilePath(Dossier);
   // on retire le dernier \
   Dossier := Copy(Dossier,1,Length(Dossier)-1);
   // On ouvre le dossier
   LanceFichier(Dossier);
   close;
 end
end;

end.
